ADS.Core/ADS.Core/Controllers/ControladoraController.cs
using ADS.Core.Model;
using ADS.Core.Unit;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ADS.Core.Controllers
{
    public class ControladoraController : Controller
    {
        private UnitOfwork _unit = new UnitOfwork();

        [HttpGet]
        public ActionResult Cadastrar()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Cadastrar(Controladora controladora)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    controladora.CriadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    _unit.ControladoraRepository.Cadastrar(controladora);
                    _unit.Salvar();
                    TempData["msg"] = "Controladora salva com sucesso!";
                    return RedirectToAction("Cadastrar");
                }
            }
            catch(Exception e)
            {
                TempData["msg"] = "Falha ao cadastrar controladora. " + e.Message;   
            }
            return View(controladora);
        }

        public ActionResult Listar(int? pagina, int? qtdPorPagina)
        {
            Pager pager = new Pager(_unit.ControladoraRepository.QuantidadeControladora(),pagina, qtdPorPagina == null ? 10 : (int)qtdPorPagina);
            ViewBag.Pager = pager;
            return View(_unit.ControladoraRepository.ListarPaginado(pager));
        }

        public PartialViewResult Detalhes(int id)
        {
            return PartialView("_Detalhes",_unit.ControladoraRepository.Buscar(id));
        }

        [HttpPost]
        public ActionResult Remover(int id)
        {
            try
            {
                _unit.ControladoraRepository.Remover(id);
                _unit.Salvar();
                TempData["msg"] = "Controladora removida com sucesso!";
            }catch(Exception e)
            {
                TempData["msg"] = "Falha ao remover controladora. " + e.Message;
            }
            return RedirectToAction("Listar");
        }

        public ActionResult Editar(int id)
        {
            return View(_unit.ControladoraRepository.Buscar(id));
        }

        [HttpPost]
        public ActionResult Editar(Controladora controladora)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    controladora.AtualizadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    _unit.ControladoraRepository.Alterar(controladora);
                    _unit.Salvar();
                    TempData["msg"] = "Controladora alterada com sucesso!";
                    return RedirectToAction("Listar");
                }
            }
            catch (Exception e)
            {
                TempData["msg"] = "Falha ao alterar controladora. " + e.Message;
            }
            return View(controladora);
        }
    }
}

ADS.Core/ADS.Core/Views/Controladora/Cadastrar.cshtml
@model ADS.Core.Model.Controladora

@{
    ViewBag.Title = "Cadastrar";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Cadastrar Controladora</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="row">
        <div class="form-group col-md-6">
            @Html.LabelFor(c => c.Nome)
            @Html.TextBoxFor(model => model.Nome, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.Nome, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Ip)
            @Html.TextBoxFor(model => model.Ip, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Ip, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Mascara)
            @Html.TextBoxFor(model => model.Mascara, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Mascara, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Gateway)
            @Html.TextBoxFor(model => model.Gateway, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Gateway, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.IpDestino)
            @Html.TextBoxFor(model => model.IpDestino, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.IpDestino, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.PortaDestino)
            @Html.TextBoxFor(model => model.PortaDestino, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PortaDestino, "", new { @class = "text-danger" })
        </div>
    </div>
    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.PortaOrigem)
            @Html.TextBoxFor(model => model.PortaOrigem, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PortaOrigem, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.MacAddress)
            @Html.TextBoxFor(model => model.MacAddress, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.MacAddress, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="row">
        <div class="form-group col-md-4">
            @Html.CheckBoxFor(model => model.Ativo) @Html.LabelFor(model => model.Ativo)               
        </div>
    </div>

    <div class="form-group">
       <button type="submit" class="btn btn-default"><i class="fa fa-save"> Salvar</i></button>
    </div>
}

@section Mascaras {
    <script src="~/Scripts/Mascaras.js"></script>
}

ADS.Core/ADS.Core/Views/Controladora/Editar.cshtml
@model ADS.Core.Model.Controladora

@{
    ViewBag.Title = "Cadastrar";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Cadastrar Controladora</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    @Html.HiddenFor(c => c.ControladoraId);
    @Html.HiddenFor(c => c.CriadoEm);
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="row">
        <div class="form-group col-md-6">
            @Html.LabelFor(c => c.Nome)
            @Html.TextBoxFor(model => model.Nome, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.Nome, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Ip)
            @Html.TextBoxFor(model => model.Ip, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Ip, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Mascara)
            @Html.TextBoxFor(model => model.Mascara, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Mascara, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.Gateway)
            @Html.TextBoxFor(model => model.Gateway, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.Gateway, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.IpDestino)
            @Html.TextBoxFor(model => model.IpDestino, new { @class = "form-control IpAddress" })
            @Html.ValidationMessageFor(model => model.IpDestino, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.PortaDestino)
            @Html.TextBoxFor(model => model.PortaDestino, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PortaDestino, "", new { @class = "text-danger" })
        </div>
    </div>
    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.PortaOrigem)
            @Html.TextBoxFor(model => model.PortaOrigem, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PortaOrigem, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="row">
        <div class="form-group col-md-4">
            @Html.LabelFor(model => model.MacAddress)
            @Html.TextBoxFor(model => model.MacAddress, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.MacAddress, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="row">
        <div class="form-group col-md-4">
            @Html.CheckBoxFor(model => model.Ativo) @Html.LabelFor(model => model.Ativo)               
        </div>
    </div>

    <div class="form-group">
       <button type="submit" class="btn btn-default"><i class="fa fa-save"> Salvar</i></button>
    </div>
}

@section Mascaras {
    <script src="~/Scripts/Mascaras.js"></script>
}

ADS.Core/ADS.Core/Views/Controladora/Listar.cshtml
@model IEnumerable<ADS.Core.Model.Controladora>

@{
    ViewBag.Title = "Listar";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Listar</h2>

<div class="row margem-abaixo">
    <div class="col-md-10">
        <span class="input-group-btn">
            <a href="@Url.Action("Cadastrar", "Controladora")" class="btn btn-primary"><i class="fa fa-plus"></i> Adicionar</a>
            <!--<a href="@Url.Action("Importar", "Controladora")" class="btn btn-primary"><i class="fa fa-plus"></i> Importar</a> -->
            <a href="@Url.Action("Remover", "Controladora")" class="btn btn-primary"><i class="fa fa-remove"></i> Remover</a>
            <a href="#" class="btn btn-primary"><i class="fa fa-search"></i> Procurar</a>
        </span>
    </div>
</div>
<table class="table table-responsive table-striped">
    <tr>
        <th><input type="checkbox" name="selectAll" id="selecionarTodos" /></th>
        <th>
            Nome
        </th>
        <th>
            Endereço IP
        </th>
        <th>
            Mac Address
        </th>
        <th>
            Ativo
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                @Html.CheckBox("chkAdv", false, new { id = item.ControladoraId })
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Nome)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Ip)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.MacAddress)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Ativo)
            </td>
            
            <td>
                <a href="../Controladora/Editar/@item.ControladoraId" onclick="editarControladora()" id=@item.ControladoraId class="glyphicon glyphicon-pencil btn btn-primary btn-xs"></a>
                <a href="#a" onclick="detalhesControladora(@item.ControladoraId)" id=@item.ControladoraId class="glyphicon glyphicon-eye-open btn btn-default btn-xs"></a>
                <a href="#a" onclick="return confirm('Deseja remover esse registro?') ? removerControladora(@item.ControladoraId) : '';" id=@item.ControladoraId class="glyphicon glyphicon-remove btn btn-danger btn-xs"></a>
            </td>
        </tr>
    }
</table>



@RenderPage("~/Views/Controladora/_PaginacaoControladora.cshtml")

<!-- MODAIS -->
<!-- Detalhes Controladora-->
<div class="modal fade" id="modalDetalhesControladora" tabindex="-1" role="dialog" aria-labelledby="Detalhes Controladora">
    <div class="modal-dialog" role="document">
        <div class="modal-content" id="detalhesControladoraBody">

        </div>
    </div>
</div>
@section ScriptControladora{
    <script src="~/Scripts/Controladora.js"></script>
}

ADS.Core/ADS.Core/Views/Controladora/_Detalhes.cshtml
@model ADS.Core.Model.Controladora

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
    <h4>@Html.DisplayFor(model => model.Nome)</h4>
</div>

<div class="modal-body container">
    <dl class="dl-horizontal">

        <dt>
            @Html.DisplayNameFor(model => model.Ip)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Ip)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Mascara)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Mascara)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Gateway)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Gateway)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IpDestino)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.IpDestino)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PortaDestino)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PortaDestino)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PortaOrigem)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PortaOrigem)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.MacAddress)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.MacAddress)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Ativo)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Ativo)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.AtualizadoEm)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AtualizadoEm)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.CriadoEm)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CriadoEm)
        </dd>

    </dl>
</div>

ADS.Core/ADS.Core/Views/Controladora/_PaginacaoControladora.cshtml
<div class="row">
    <nav aria-label="Page navigation">
        <ul class="pagination" id="paginacao">
            <input type="hidden" value="@ViewBag.Pager.CurrentPage" id="paginaAtual" name="paginaAtual" />
            @if (ViewBag.Pager.CurrentPage > 1)
            {
                <li>
                    <a href="~/Controladora/Listar?pagina=@(ViewBag.Pager.CurrentPage - 1)&qtdPorPagina=10" aria-label="Previous">
                        <span aria-hidden="true">&laquo;</span>
                    </a>
                </li>
            }
            @for (var i = ViewBag.Pager.StartPage; i <= ViewBag.Pager.EndPage; i++)
            {
                <li class="@(i == ViewBag.Pager.CurrentPage ? "active" : "")">
                    <a href="~/Controladora/Listar?pagina=@i&qtdPorPagina=10">@i</a>
                </li>
            }
            @if (ViewBag.Pager.CurrentPage < ViewBag.Pager.TotalPages)
            {
                <li>
                    <a href="~/Controladora/Listar?pagina=@(ViewBag.Pager.CurrentPage + 1)&qtdPorPagina=10" aria-label="Next">
                        <span aria-hidden="true">&raquo;</span>
                    </a>
                </li>
            }
        </ul>

    </nav>
</div>
<div class="row">
    <span class="small">Total de @ViewBag.Pager.TotalItems registros</span>
</div>